'-------------------------------------------------------------------------------
' In The Name Of GOD

'Topic  : USB Send Byte Test
'Author : Morteza Rahimi Kordmahalle (MRK)
'Microcontroller : ATmega8

'Compiler : BASCOM 2.0.7.3
'Creation Date : Jun 29, 2012 (1391.04.08)
'Copyright : (C) 2011 By www.mrkelectronic.blogfa.com
'License : This Is A Free Firmware , Ver 1.00

'-------------------------------------------------------------------------------
$hwstack = 40
$swstack = 40
$framesize = 50

$regfile = "m8def.dat"
$crystal = 12000000

'Include the software USB library
$lib "swusb.lbx"
$external _swusb
$external Crcusb

Declare Sub Usb_reset()
Declare Sub Usb_processsetup(txstate As Byte)
Declare Sub Usb_send(txstate As Byte , Byval Count As Byte)
Declare Sub Usb_senddescriptor(txstate As Byte , Maxlen As Byte)
Declare Function Crcusb(buffer() As Byte , Count As Byte) As Word

'*************************** Begin USB Configuration ***************************
$include "USB-Configurations.bas"
$include "swusb-includes.bas"

'**************************** USB Interrupt And Init ***************************
'Set all the variables, flags, and sync bits to their initial states
Call Usb_reset()

Const _usb_intf = Intf0
Config Int0 = Rising
On Int0 Usb_isr Nosave
Enable Int0

'******************************** Configurations *******************************
Config Portc.5 = Input
Config Portc.4 = Input
Config Portc.3 = Input
Config Portc.2 = Input
Enable Interrupts

'*********************************** Variables *********************************
Dim Resetcounter As Word
Dim Idlemode As Byte
Dim Device_configured As Byte
Dim Ch As String * 10
Dim A As String * 10
Dim Count As Byte
Dim Lenn As Byte

A = "salam"

'********************************** Main Program *******************************
Do

   Resetcounter = 0

   'Check for reset here
   While _usb_pin._usb_dminus = 0
      Incr Resetcounter
      If Resetcounter = 1000 Then
         Call Usb_reset()
      End If
   Wend


   'Check for received data
   If _usb_status._usb_rxc = 1 Then
      If _usb_status._usb_setup = 1 Then
         'Process a setup packet/Control message
         Call Usb_processsetup(_usb_tx_status)
      Elseif _usb_status._usb_endp1 = 1 Then
         ' Input data endpoints
      End If
      'Reset the RXC bit and set the RTR bit (ready to receive a new packet)
      _usb_status._usb_rtr = 1
      _usb_status._usb_rxc = 0
   End If





If _usb_tx_status2._usb_txc = 1 And Pinc.5 = 1 Then
While Count < Lenn
Ch = Mid(a , Count , 1)
_usb_tx_buffer2(2) = Asc(ch)                                'Put our Byte in the TX buffer

Call Usb_send(_usb_tx_status2 , 1)                          'Send data to PC
Count = 1 + Count
Wend
End If






      If Pinc.4 = 1 Then

      'Queue data to be sent on endpoint 2 (HID report)
      If _usb_tx_status2._usb_txc = 1 Then

          _usb_tx_buffer2(2) = 93                           'Put our Byte in the TX buffer
          Call Usb_send(_usb_tx_status2 , 1)                'Send data to PC

      End If

   End If

         If Pinc.3 = 1 Then

      'Queue data to be sent on endpoint 2 (HID report)
      If _usb_tx_status2._usb_txc = 1 Then

          _usb_tx_buffer2(2) = 3                            'Put our Byte in the TX buffer
          Call Usb_send(_usb_tx_status2 , 1)                'Send data to PC

      End If


   End If


         If Pinc.2 = 1 Then

      'Queue data to be sent on endpoint 2 (HID report)
      If _usb_tx_status2._usb_txc = 1 Then

          _usb_tx_buffer2(2) = 2                            'Put our Byte in the TX buffer
          Call Usb_send(_usb_tx_status2 , 1)                'Send data to PC

      End If


   End If

Loop

End

'******************** Descriptors stored in EEPROM or FLASH ********************
$include "USB-Descriptors.bas"

'******************************** Subroutines **********************************
$include "USB-Functions.bas"